=== systemtests/tests/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2021-2025 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.

message("Adding systemtests from ${CMAKE_CURRENT_SOURCE_DIR}")
add_subdirectory(accurate-lmdb-stresstest)
add_subdirectory(accurate-stresstest)
add_subdirectory(acl)
add_subdirectory(always-incremental-consolidate)
add_subdirectory(autochanger)
add_subdirectory(autoxflate)
add_subdirectory(auto-grpc)
add_subdirectory(bareos-basic)
add_subdirectory(bareos-concurrency)
add_subdirectory(bareos-acl)
add_subdirectory(bconsole-basic)
add_subdirectory(bconsole-pam)
add_subdirectory(block-size)
add_subdirectory(bscan-bextract-bls-bcopy-btape)
add_subdirectory(catalog)
add_subdirectory(checkpoints)
add_subdirectory(chflags)
add_subdirectory(client-initiated)
add_subdirectory(commandline-options)
add_subdirectory(config-dump)
add_subdirectory(copy-migrate)
add_subdirectory(copy-archive-job)
add_subdirectory(dbcheck)
add_subdirectory(dedupable)
add_subdirectory(dedupestimate)
add_subdirectory(deprecation)
add_subdirectory(droplet-s3)
add_subdirectory(dplcompat)
add_subdirectory(encrypt-signature-no-tls)
add_subdirectory(encrypt-signature-tls-cert)
add_subdirectory(fileindex-overflow)
if(HAVE_DYNAMIC_SD_BACKENDS)
  add_subdirectory(file-autochanger)
endif()
add_subdirectory(file-count-regression)
add_subdirectory(fileset-multiple-blocks)
add_subdirectory(filesets)
add_subdirectory(gfapi-fd)
add_subdirectory(glusterfs-backend)
add_subdirectory(grpc-fd)
add_subdirectory(heartbeat-interval)
add_subdirectory(ignoreduplicatecheck)
add_subdirectory(just-in-time-reservation)
add_subdirectory(list-backups)
add_subdirectory(messages)
add_subdirectory(mtx-changer)
add_subdirectory(multiplied-device)
add_subdirectory(multiple-clients)
add_subdirectory(ndmp-bareos)
add_subdirectory(ndmp-native)
if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  add_subdirectory(mssqlvdi-plugin)
endif()
add_subdirectory(notls)
add_subdirectory(parallel-jobs)
add_subdirectory(parser)
add_subdirectory(passive)
add_subdirectory(pruning)
add_subdirectory(py3plug-fd-basic)
add_subdirectory(py3plug-fd-contrib-bareos_tasks_mariadb)
add_subdirectory(py3plug-fd-contrib-bareos_tasks_mysql)
add_subdirectory(py3plug-fd-contrib-mariadb-dump)
add_subdirectory(py3plug-fd-contrib-mysql_dump)
add_subdirectory(py3plug-fd-ldap)
add_subdirectory(py3plug-fd-libcloud)
add_subdirectory(py3plug-fd-local-fileset-basic)
add_subdirectory(py3plug-fd-local-fileset-restoreobject)
add_subdirectory(py3plug-fd-mariabackup)
add_subdirectory(py3plug-fd-percona-xtrabackup)
add_subdirectory(py3plug-fd-postgresql)
add_subdirectory(py3plug-fd-vmware)

add_subdirectory(py3plug-dir)
add_subdirectory(py3plug-sd)

add_subdirectory(python-bareos)
add_subdirectory(python-pam)
add_subdirectory(quota-softquota)
add_subdirectory(reload)
add_subdirectory(restapi)
add_subdirectory(restore)
add_subdirectory(scheduler)
add_subdirectory(scsicrypto)
add_subdirectory(sd-volume-limit)
add_subdirectory(sparse-file)
add_subdirectory(spool)
add_subdirectory(stresstest)
add_subdirectory(strippath)
add_subdirectory(testfind)
add_subdirectory(tlsrestricted)
add_subdirectory(tls-suites)
add_subdirectory(truncate-command)
add_subdirectory(upgrade-database)
add_subdirectory(virtualfull-basic)
add_subdirectory(virtualfull-bscan)
add_subdirectory(virtualfull-deletedfiles)
add_subdirectory(xattr)
