=== debian/changelog ===
bareos (25.0.0~pre598.bb9830860-32) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Tue, 03 Jun 2025 08:50:30 +0000
